/* HtmlToMarkdown.c generated by valac 0.48.19, the Vala compiler
 * generated from HtmlToMarkdown.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <gobject/gvaluecollector.h>

#define TYPE_HTML_TO_MARKDOWN (html_to_markdown_get_type ())
#define HTML_TO_MARKDOWN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HTML_TO_MARKDOWN, HtmlToMarkdown))
#define HTML_TO_MARKDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HTML_TO_MARKDOWN, HtmlToMarkdownClass))
#define IS_HTML_TO_MARKDOWN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HTML_TO_MARKDOWN))
#define IS_HTML_TO_MARKDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HTML_TO_MARKDOWN))
#define HTML_TO_MARKDOWN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HTML_TO_MARKDOWN, HtmlToMarkdownClass))

typedef struct _HtmlToMarkdown HtmlToMarkdown;
typedef struct _HtmlToMarkdownClass HtmlToMarkdownClass;
typedef struct _HtmlToMarkdownPrivate HtmlToMarkdownPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _xmlFreeDoc0(var) ((var == NULL) ? NULL : (var = (xmlFreeDoc (var), NULL)))
typedef struct _ParamSpecHtmlToMarkdown ParamSpecHtmlToMarkdown;

struct _HtmlToMarkdown {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HtmlToMarkdownPrivate * priv;
};

struct _HtmlToMarkdownClass {
	GTypeClass parent_class;
	void (*finalize) (HtmlToMarkdown *self);
};

struct _ParamSpecHtmlToMarkdown {
	GParamSpec parent_instance;
};

static gpointer html_to_markdown_parent_class = NULL;
extern gint html_to_markdown_list_depth;
gint html_to_markdown_list_depth = -1;
extern gboolean html_to_markdown_extensions;
gboolean html_to_markdown_extensions = TRUE;

gpointer html_to_markdown_ref (gpointer instance);
void html_to_markdown_unref (gpointer instance);
GParamSpec* param_spec_html_to_markdown (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void value_set_html_to_markdown (GValue* value,
                                 gpointer v_object);
void value_take_html_to_markdown (GValue* value,
                                  gpointer v_object);
gpointer value_get_html_to_markdown (const GValue* value);
GType html_to_markdown_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HtmlToMarkdown, html_to_markdown_unref)
void html_to_markdown_reset (gboolean ext);
gchar* html_to_markdown_parse_file (const gchar* fname);
gchar* html_to_markdown_parse_xml (xmlNode* n);
gchar* html_to_markdown_parse_item (xmlNode* n);
gchar* html_to_markdown_parse_list (xmlNode* n,
                                    gboolean unordered,
                                    gint depth);
gchar* html_to_markdown_parse_link (xmlNode* n);
gchar* html_to_markdown_parse_image (xmlNode* n);
gchar* html_to_markdown_parse_table (xmlNode* n);
gchar* html_to_markdown_parse_node (xmlNode* n);
gchar* html_to_markdown_parse_table_row (xmlNode* n,
                                         gint* cols);
HtmlToMarkdown* html_to_markdown_new (void);
HtmlToMarkdown* html_to_markdown_construct (GType object_type);
static void html_to_markdown_finalize (HtmlToMarkdown * obj);
static GType html_to_markdown_get_type_once (void);

void
html_to_markdown_reset (gboolean ext)
{
	html_to_markdown_list_depth = -1;
	html_to_markdown_extensions = ext;
}

gchar*
html_to_markdown_parse_file (const gchar* fname)
{
	xmlDoc* doc = NULL;
	xmlDoc* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
	xmlDoc* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (fname != NULL, NULL);
	_tmp0_ = xmlReadFile (fname, NULL, (gint) XML_PARSE_HUGE);
	doc = _tmp0_;
	_tmp1_ = g_strdup ("");
	text = _tmp1_;
	_tmp2_ = doc;
	if (_tmp2_ != NULL) {
		xmlDoc* _tmp3_;
		xmlNode* _tmp4_;
		gchar* _tmp5_;
		xmlDoc* _tmp6_;
		_tmp3_ = doc;
		_tmp4_ = xmlDocGetRootElement (_tmp3_);
		_tmp5_ = html_to_markdown_parse_xml (_tmp4_);
		_g_free0 (text);
		text = _tmp5_;
		_tmp6_ = doc;
		_xmlFreeDoc0 (_tmp6_);
	}
	result = text;
	return result;
}

gchar*
html_to_markdown_parse_xml (xmlNode* n)
{
	gchar* _tmp14_;
	gchar* result = NULL;
	{
		xmlNode* it = NULL;
		xmlNode* _tmp0_;
		_tmp0_ = n->children;
		it = _tmp0_;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp4_;
				gboolean _tmp5_ = FALSE;
				xmlNode* _tmp6_;
				xmlElementType _tmp7_;
				if (!_tmp1_) {
					xmlNode* _tmp2_;
					xmlNode* _tmp3_;
					_tmp2_ = it;
					_tmp3_ = _tmp2_->next;
					it = _tmp3_;
				}
				_tmp1_ = FALSE;
				_tmp4_ = it;
				if (!(_tmp4_ != NULL)) {
					break;
				}
				_tmp6_ = it;
				_tmp7_ = _tmp6_->type;
				if (_tmp7_ == XML_ELEMENT_NODE) {
					xmlNode* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					_tmp8_ = it;
					_tmp9_ = _tmp8_->name;
					_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) -1);
					_tmp11_ = _tmp10_;
					_tmp5_ = g_strcmp0 (_tmp11_, "body") == 0;
					_g_free0 (_tmp11_);
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					xmlNode* _tmp12_;
					gchar* _tmp13_;
					_tmp12_ = it;
					_tmp13_ = html_to_markdown_parse_item (_tmp12_);
					result = _tmp13_;
					return result;
				}
			}
		}
	}
	_tmp14_ = g_strdup ("");
	result = _tmp14_;
	return result;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

gchar*
html_to_markdown_parse_item (xmlNode* n)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp191_;
	gchar* _tmp192_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("");
	text = _tmp0_;
	{
		xmlNode* it = NULL;
		xmlNode* _tmp1_;
		_tmp1_ = n->children;
		it = _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp5_;
				xmlNode* _tmp6_;
				xmlElementType _tmp7_;
				if (!_tmp2_) {
					xmlNode* _tmp3_;
					xmlNode* _tmp4_;
					_tmp3_ = it;
					_tmp4_ = _tmp3_->next;
					it = _tmp4_;
				}
				_tmp2_ = FALSE;
				_tmp5_ = it;
				if (!(_tmp5_ != NULL)) {
					break;
				}
				_tmp6_ = it;
				_tmp7_ = _tmp6_->type;
				switch (_tmp7_) {
					case XML_ELEMENT_NODE:
					{
						xmlNode* _tmp8_;
						const gchar* _tmp9_;
						gchar* _tmp10_;
						gchar* _tmp11_;
						GQuark _tmp13_ = 0U;
						static GQuark _tmp12_label0 = 0;
						static GQuark _tmp12_label1 = 0;
						static GQuark _tmp12_label2 = 0;
						static GQuark _tmp12_label3 = 0;
						static GQuark _tmp12_label4 = 0;
						static GQuark _tmp12_label5 = 0;
						static GQuark _tmp12_label6 = 0;
						static GQuark _tmp12_label7 = 0;
						static GQuark _tmp12_label8 = 0;
						static GQuark _tmp12_label9 = 0;
						static GQuark _tmp12_label10 = 0;
						static GQuark _tmp12_label11 = 0;
						static GQuark _tmp12_label12 = 0;
						static GQuark _tmp12_label13 = 0;
						static GQuark _tmp12_label14 = 0;
						static GQuark _tmp12_label15 = 0;
						static GQuark _tmp12_label16 = 0;
						static GQuark _tmp12_label17 = 0;
						static GQuark _tmp12_label18 = 0;
						static GQuark _tmp12_label19 = 0;
						static GQuark _tmp12_label20 = 0;
						static GQuark _tmp12_label21 = 0;
						_tmp8_ = it;
						_tmp9_ = _tmp8_->name;
						_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) -1);
						_tmp11_ = _tmp10_;
						_tmp13_ = (NULL == _tmp11_) ? 0 : g_quark_from_string (_tmp11_);
						g_free (_tmp11_);
						if (_tmp13_ == ((0 != _tmp12_label0) ? _tmp12_label0 : (_tmp12_label0 = g_quark_from_static_string ("p")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp14_;
									xmlNode* _tmp15_;
									gchar* _tmp16_;
									gchar* _tmp17_;
									gchar* _tmp18_;
									gchar* _tmp19_;
									gchar* _tmp20_;
									_tmp14_ = text;
									_tmp15_ = it;
									_tmp16_ = html_to_markdown_parse_item (_tmp15_);
									_tmp17_ = _tmp16_;
									_tmp18_ = g_strconcat ("\n\n", _tmp17_, NULL);
									_tmp19_ = _tmp18_;
									_tmp20_ = g_strconcat (_tmp14_, _tmp19_, NULL);
									_g_free0 (text);
									text = _tmp20_;
									_g_free0 (_tmp19_);
									_g_free0 (_tmp17_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label1) ? _tmp12_label1 : (_tmp12_label1 = g_quark_from_static_string ("blockquote")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp21_;
									xmlNode* _tmp22_;
									gchar* _tmp23_;
									gchar* _tmp24_;
									gchar* _tmp25_;
									gchar* _tmp26_;
									gchar* _tmp27_;
									_tmp21_ = text;
									_tmp22_ = it;
									_tmp23_ = html_to_markdown_parse_item (_tmp22_);
									_tmp24_ = _tmp23_;
									_tmp25_ = g_strconcat ("\n\n> ", _tmp24_, NULL);
									_tmp26_ = _tmp25_;
									_tmp27_ = g_strconcat (_tmp21_, _tmp26_, NULL);
									_g_free0 (text);
									text = _tmp27_;
									_g_free0 (_tmp26_);
									_g_free0 (_tmp24_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label2) ? _tmp12_label2 : (_tmp12_label2 = g_quark_from_static_string ("div")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp28_;
									xmlNode* _tmp29_;
									gchar* _tmp30_;
									gchar* _tmp31_;
									gchar* _tmp32_;
									gchar* _tmp33_;
									gchar* _tmp34_;
									_tmp28_ = text;
									_tmp29_ = it;
									_tmp30_ = html_to_markdown_parse_item (_tmp29_);
									_tmp31_ = _tmp30_;
									_tmp32_ = g_strconcat ("\n\n", _tmp31_, NULL);
									_tmp33_ = _tmp32_;
									_tmp34_ = g_strconcat (_tmp28_, _tmp33_, NULL);
									_g_free0 (text);
									text = _tmp34_;
									_g_free0 (_tmp33_);
									_g_free0 (_tmp31_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label3) ? _tmp12_label3 : (_tmp12_label3 = g_quark_from_static_string ("span")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp35_;
									xmlNode* _tmp36_;
									gchar* _tmp37_;
									gchar* _tmp38_;
									gchar* _tmp39_;
									_tmp35_ = text;
									_tmp36_ = it;
									_tmp37_ = html_to_markdown_parse_item (_tmp36_);
									_tmp38_ = _tmp37_;
									_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
									_g_free0 (text);
									text = _tmp39_;
									_g_free0 (_tmp38_);
									break;
								}
							}
						} else if ((_tmp13_ == ((0 != _tmp12_label4) ? _tmp12_label4 : (_tmp12_label4 = g_quark_from_static_string ("strong")))) || (_tmp13_ == ((0 != _tmp12_label5) ? _tmp12_label5 : (_tmp12_label5 = g_quark_from_static_string ("b"))))) {
							switch (0) {
								default:
								{
									const gchar* _tmp40_;
									xmlNode* _tmp41_;
									gchar* _tmp42_;
									gchar* _tmp43_;
									gchar* _tmp44_;
									gchar* _tmp45_;
									gchar* _tmp46_;
									gchar* _tmp47_;
									gchar* _tmp48_;
									_tmp40_ = text;
									_tmp41_ = it;
									_tmp42_ = html_to_markdown_parse_item (_tmp41_);
									_tmp43_ = _tmp42_;
									_tmp44_ = g_strconcat ("**", _tmp43_, NULL);
									_tmp45_ = _tmp44_;
									_tmp46_ = g_strconcat (_tmp45_, "**", NULL);
									_tmp47_ = _tmp46_;
									_tmp48_ = g_strconcat (_tmp40_, _tmp47_, NULL);
									_g_free0 (text);
									text = _tmp48_;
									_g_free0 (_tmp47_);
									_g_free0 (_tmp45_);
									_g_free0 (_tmp43_);
									break;
								}
							}
						} else if ((_tmp13_ == ((0 != _tmp12_label6) ? _tmp12_label6 : (_tmp12_label6 = g_quark_from_static_string ("em")))) || (_tmp13_ == ((0 != _tmp12_label7) ? _tmp12_label7 : (_tmp12_label7 = g_quark_from_static_string ("i"))))) {
							switch (0) {
								default:
								{
									const gchar* _tmp49_;
									xmlNode* _tmp50_;
									gchar* _tmp51_;
									gchar* _tmp52_;
									gchar* _tmp53_;
									gchar* _tmp54_;
									gchar* _tmp55_;
									gchar* _tmp56_;
									gchar* _tmp57_;
									_tmp49_ = text;
									_tmp50_ = it;
									_tmp51_ = html_to_markdown_parse_item (_tmp50_);
									_tmp52_ = _tmp51_;
									_tmp53_ = g_strconcat ("_", _tmp52_, NULL);
									_tmp54_ = _tmp53_;
									_tmp55_ = g_strconcat (_tmp54_, "_", NULL);
									_tmp56_ = _tmp55_;
									_tmp57_ = g_strconcat (_tmp49_, _tmp56_, NULL);
									_g_free0 (text);
									text = _tmp57_;
									_g_free0 (_tmp56_);
									_g_free0 (_tmp54_);
									_g_free0 (_tmp52_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label8) ? _tmp12_label8 : (_tmp12_label8 = g_quark_from_static_string ("ul")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp58_;
									xmlNode* _tmp59_;
									gchar* _tmp60_;
									gchar* _tmp61_;
									gchar* _tmp62_;
									_tmp58_ = text;
									_tmp59_ = it;
									_tmp60_ = html_to_markdown_parse_list (_tmp59_, TRUE, 0);
									_tmp61_ = _tmp60_;
									_tmp62_ = g_strconcat (_tmp58_, _tmp61_, NULL);
									_g_free0 (text);
									text = _tmp62_;
									_g_free0 (_tmp61_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label9) ? _tmp12_label9 : (_tmp12_label9 = g_quark_from_static_string ("ol")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp63_;
									xmlNode* _tmp64_;
									gchar* _tmp65_;
									gchar* _tmp66_;
									gchar* _tmp67_;
									_tmp63_ = text;
									_tmp64_ = it;
									_tmp65_ = html_to_markdown_parse_list (_tmp64_, FALSE, 0);
									_tmp66_ = _tmp65_;
									_tmp67_ = g_strconcat (_tmp63_, _tmp66_, NULL);
									_g_free0 (text);
									text = _tmp67_;
									_g_free0 (_tmp66_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label10) ? _tmp12_label10 : (_tmp12_label10 = g_quark_from_static_string ("h1")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp68_;
									xmlNode* _tmp69_;
									gchar* _tmp70_;
									gchar* _tmp71_;
									gchar* _tmp72_;
									gchar* _tmp73_;
									gchar* _tmp74_;
									_tmp68_ = text;
									_tmp69_ = it;
									_tmp70_ = html_to_markdown_parse_item (_tmp69_);
									_tmp71_ = _tmp70_;
									_tmp72_ = g_strconcat ("\n\n# ", _tmp71_, NULL);
									_tmp73_ = _tmp72_;
									_tmp74_ = g_strconcat (_tmp68_, _tmp73_, NULL);
									_g_free0 (text);
									text = _tmp74_;
									_g_free0 (_tmp73_);
									_g_free0 (_tmp71_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label11) ? _tmp12_label11 : (_tmp12_label11 = g_quark_from_static_string ("h2")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp75_;
									xmlNode* _tmp76_;
									gchar* _tmp77_;
									gchar* _tmp78_;
									gchar* _tmp79_;
									gchar* _tmp80_;
									gchar* _tmp81_;
									_tmp75_ = text;
									_tmp76_ = it;
									_tmp77_ = html_to_markdown_parse_item (_tmp76_);
									_tmp78_ = _tmp77_;
									_tmp79_ = g_strconcat ("\n\n## ", _tmp78_, NULL);
									_tmp80_ = _tmp79_;
									_tmp81_ = g_strconcat (_tmp75_, _tmp80_, NULL);
									_g_free0 (text);
									text = _tmp81_;
									_g_free0 (_tmp80_);
									_g_free0 (_tmp78_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label12) ? _tmp12_label12 : (_tmp12_label12 = g_quark_from_static_string ("h3")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp82_;
									xmlNode* _tmp83_;
									gchar* _tmp84_;
									gchar* _tmp85_;
									gchar* _tmp86_;
									gchar* _tmp87_;
									gchar* _tmp88_;
									_tmp82_ = text;
									_tmp83_ = it;
									_tmp84_ = html_to_markdown_parse_item (_tmp83_);
									_tmp85_ = _tmp84_;
									_tmp86_ = g_strconcat ("\n\n### ", _tmp85_, NULL);
									_tmp87_ = _tmp86_;
									_tmp88_ = g_strconcat (_tmp82_, _tmp87_, NULL);
									_g_free0 (text);
									text = _tmp88_;
									_g_free0 (_tmp87_);
									_g_free0 (_tmp85_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label13) ? _tmp12_label13 : (_tmp12_label13 = g_quark_from_static_string ("h4")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp89_;
									xmlNode* _tmp90_;
									gchar* _tmp91_;
									gchar* _tmp92_;
									gchar* _tmp93_;
									gchar* _tmp94_;
									gchar* _tmp95_;
									_tmp89_ = text;
									_tmp90_ = it;
									_tmp91_ = html_to_markdown_parse_item (_tmp90_);
									_tmp92_ = _tmp91_;
									_tmp93_ = g_strconcat ("\n\n#### ", _tmp92_, NULL);
									_tmp94_ = _tmp93_;
									_tmp95_ = g_strconcat (_tmp89_, _tmp94_, NULL);
									_g_free0 (text);
									text = _tmp95_;
									_g_free0 (_tmp94_);
									_g_free0 (_tmp92_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label14) ? _tmp12_label14 : (_tmp12_label14 = g_quark_from_static_string ("h5")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp96_;
									xmlNode* _tmp97_;
									gchar* _tmp98_;
									gchar* _tmp99_;
									gchar* _tmp100_;
									gchar* _tmp101_;
									gchar* _tmp102_;
									_tmp96_ = text;
									_tmp97_ = it;
									_tmp98_ = html_to_markdown_parse_item (_tmp97_);
									_tmp99_ = _tmp98_;
									_tmp100_ = g_strconcat ("\n\n##### ", _tmp99_, NULL);
									_tmp101_ = _tmp100_;
									_tmp102_ = g_strconcat (_tmp96_, _tmp101_, NULL);
									_g_free0 (text);
									text = _tmp102_;
									_g_free0 (_tmp101_);
									_g_free0 (_tmp99_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label15) ? _tmp12_label15 : (_tmp12_label15 = g_quark_from_static_string ("h6")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp103_;
									xmlNode* _tmp104_;
									gchar* _tmp105_;
									gchar* _tmp106_;
									gchar* _tmp107_;
									gchar* _tmp108_;
									gchar* _tmp109_;
									_tmp103_ = text;
									_tmp104_ = it;
									_tmp105_ = html_to_markdown_parse_item (_tmp104_);
									_tmp106_ = _tmp105_;
									_tmp107_ = g_strconcat ("\n\n###### ", _tmp106_, NULL);
									_tmp108_ = _tmp107_;
									_tmp109_ = g_strconcat (_tmp103_, _tmp108_, NULL);
									_g_free0 (text);
									text = _tmp109_;
									_g_free0 (_tmp108_);
									_g_free0 (_tmp106_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label16) ? _tmp12_label16 : (_tmp12_label16 = g_quark_from_static_string ("hr")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp110_;
									gchar* _tmp111_;
									_tmp110_ = text;
									_tmp111_ = g_strconcat (_tmp110_, "\n\n---\n\n", NULL);
									_g_free0 (text);
									text = _tmp111_;
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label17) ? _tmp12_label17 : (_tmp12_label17 = g_quark_from_static_string ("br")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp112_;
									gchar* _tmp113_;
									_tmp112_ = text;
									_tmp113_ = g_strconcat (_tmp112_, "\n", NULL);
									_g_free0 (text);
									text = _tmp113_;
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label18) ? _tmp12_label18 : (_tmp12_label18 = g_quark_from_static_string ("a")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp114_;
									xmlNode* _tmp115_;
									gchar* _tmp116_;
									gchar* _tmp117_;
									gchar* _tmp118_;
									_tmp114_ = text;
									_tmp115_ = it;
									_tmp116_ = html_to_markdown_parse_link (_tmp115_);
									_tmp117_ = _tmp116_;
									_tmp118_ = g_strconcat (_tmp114_, _tmp117_, NULL);
									_g_free0 (text);
									text = _tmp118_;
									_g_free0 (_tmp117_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label19) ? _tmp12_label19 : (_tmp12_label19 = g_quark_from_static_string ("code")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp119_;
									xmlNode* _tmp120_;
									gchar* _tmp121_;
									gchar* _tmp122_;
									gchar* _tmp123_;
									gchar* _tmp124_;
									gchar* _tmp125_;
									gchar* _tmp126_;
									gchar* _tmp127_;
									_tmp119_ = text;
									_tmp120_ = it;
									_tmp121_ = html_to_markdown_parse_item (_tmp120_);
									_tmp122_ = _tmp121_;
									_tmp123_ = g_strconcat ("`", _tmp122_, NULL);
									_tmp124_ = _tmp123_;
									_tmp125_ = g_strconcat (_tmp124_, "`", NULL);
									_tmp126_ = _tmp125_;
									_tmp127_ = g_strconcat (_tmp119_, _tmp126_, NULL);
									_g_free0 (text);
									text = _tmp127_;
									_g_free0 (_tmp126_);
									_g_free0 (_tmp124_);
									_g_free0 (_tmp122_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label20) ? _tmp12_label20 : (_tmp12_label20 = g_quark_from_static_string ("img")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp128_;
									xmlNode* _tmp129_;
									gchar* _tmp130_;
									gchar* _tmp131_;
									gchar* _tmp132_;
									_tmp128_ = text;
									_tmp129_ = it;
									_tmp130_ = html_to_markdown_parse_image (_tmp129_);
									_tmp131_ = _tmp130_;
									_tmp132_ = g_strconcat (_tmp128_, _tmp131_, NULL);
									_g_free0 (text);
									text = _tmp132_;
									_g_free0 (_tmp131_);
									break;
								}
							}
						} else if (_tmp13_ == ((0 != _tmp12_label21) ? _tmp12_label21 : (_tmp12_label21 = g_quark_from_static_string ("pre")))) {
							switch (0) {
								default:
								{
									const gchar* _tmp133_;
									xmlNode* _tmp134_;
									gchar* _tmp135_;
									gchar* _tmp136_;
									gchar* _tmp137_;
									gchar* _tmp138_;
									gchar* _tmp139_;
									gchar* _tmp140_;
									gchar* _tmp141_;
									_tmp133_ = text;
									_tmp134_ = it;
									_tmp135_ = html_to_markdown_parse_item (_tmp134_);
									_tmp136_ = _tmp135_;
									_tmp137_ = g_strconcat ("\n\n```\n", _tmp136_, NULL);
									_tmp138_ = _tmp137_;
									_tmp139_ = g_strconcat (_tmp138_, "\n```", NULL);
									_tmp140_ = _tmp139_;
									_tmp141_ = g_strconcat (_tmp133_, _tmp140_, NULL);
									_g_free0 (text);
									text = _tmp141_;
									_g_free0 (_tmp140_);
									_g_free0 (_tmp138_);
									_g_free0 (_tmp136_);
									break;
								}
							}
						} else {
							switch (0) {
								default:
								{
									if (html_to_markdown_extensions) {
										xmlNode* _tmp142_;
										const gchar* _tmp143_;
										gchar* _tmp144_;
										gchar* _tmp145_;
										GQuark _tmp147_ = 0U;
										static GQuark _tmp146_label0 = 0;
										static GQuark _tmp146_label1 = 0;
										_tmp142_ = it;
										_tmp143_ = _tmp142_->name;
										_tmp144_ = g_utf8_strdown (_tmp143_, (gssize) -1);
										_tmp145_ = _tmp144_;
										_tmp147_ = (NULL == _tmp145_) ? 0 : g_quark_from_string (_tmp145_);
										g_free (_tmp145_);
										if (_tmp147_ == ((0 != _tmp146_label0) ? _tmp146_label0 : (_tmp146_label0 = g_quark_from_static_string ("del")))) {
											switch (0) {
												default:
												{
													const gchar* _tmp148_;
													xmlNode* _tmp149_;
													gchar* _tmp150_;
													gchar* _tmp151_;
													gchar* _tmp152_;
													gchar* _tmp153_;
													gchar* _tmp154_;
													gchar* _tmp155_;
													gchar* _tmp156_;
													_tmp148_ = text;
													_tmp149_ = it;
													_tmp150_ = html_to_markdown_parse_item (_tmp149_);
													_tmp151_ = _tmp150_;
													_tmp152_ = g_strconcat ("~~", _tmp151_, NULL);
													_tmp153_ = _tmp152_;
													_tmp154_ = g_strconcat (_tmp153_, "~~", NULL);
													_tmp155_ = _tmp154_;
													_tmp156_ = g_strconcat (_tmp148_, _tmp155_, NULL);
													_g_free0 (text);
													text = _tmp156_;
													_g_free0 (_tmp155_);
													_g_free0 (_tmp153_);
													_g_free0 (_tmp151_);
													break;
												}
											}
										} else if (_tmp147_ == ((0 != _tmp146_label1) ? _tmp146_label1 : (_tmp146_label1 = g_quark_from_static_string ("table")))) {
											switch (0) {
												default:
												{
													const gchar* _tmp157_;
													xmlNode* _tmp158_;
													gchar* _tmp159_;
													gchar* _tmp160_;
													gchar* _tmp161_;
													gchar* _tmp162_;
													gchar* _tmp163_;
													_tmp157_ = text;
													_tmp158_ = it;
													_tmp159_ = html_to_markdown_parse_table (_tmp158_);
													_tmp160_ = _tmp159_;
													_tmp161_ = g_strconcat ("\n\n", _tmp160_, NULL);
													_tmp162_ = _tmp161_;
													_tmp163_ = g_strconcat (_tmp157_, _tmp162_, NULL);
													_g_free0 (text);
													text = _tmp163_;
													_g_free0 (_tmp162_);
													_g_free0 (_tmp160_);
													break;
												}
											}
										} else {
											switch (0) {
												default:
												{
													const gchar* _tmp164_;
													xmlNode* _tmp165_;
													gchar* _tmp166_;
													gchar* _tmp167_;
													gchar* _tmp168_;
													_tmp164_ = text;
													_tmp165_ = it;
													_tmp166_ = html_to_markdown_parse_node (_tmp165_);
													_tmp167_ = _tmp166_;
													_tmp168_ = g_strconcat (_tmp164_, _tmp167_, NULL);
													_g_free0 (text);
													text = _tmp168_;
													_g_free0 (_tmp167_);
													break;
												}
											}
										}
									} else {
										const gchar* _tmp169_;
										xmlNode* _tmp170_;
										gchar* _tmp171_;
										gchar* _tmp172_;
										gchar* _tmp173_;
										_tmp169_ = text;
										_tmp170_ = it;
										_tmp171_ = html_to_markdown_parse_node (_tmp170_);
										_tmp172_ = _tmp171_;
										_tmp173_ = g_strconcat (_tmp169_, _tmp172_, NULL);
										_g_free0 (text);
										text = _tmp173_;
										_g_free0 (_tmp172_);
									}
									break;
								}
							}
						}
						break;
					}
					case XML_TEXT_NODE:
					{
						xmlNode* _tmp174_;
						const gchar* _tmp175_;
						gchar* _tmp176_;
						gchar* _tmp177_;
						gboolean _tmp178_;
						_tmp174_ = it;
						_tmp175_ = _tmp174_->content;
						_tmp176_ = string_strip (_tmp175_);
						_tmp177_ = _tmp176_;
						_tmp178_ = g_strcmp0 (_tmp177_, "") != 0;
						_g_free0 (_tmp177_);
						if (_tmp178_) {
							const gchar* _tmp179_;
							xmlNode* _tmp180_;
							const gchar* _tmp181_;
							gchar* _tmp182_;
							_tmp179_ = text;
							_tmp180_ = it;
							_tmp181_ = _tmp180_->content;
							_tmp182_ = g_strconcat (_tmp179_, _tmp181_, NULL);
							_g_free0 (text);
							text = _tmp182_;
						}
						break;
					}
					case XML_CDATA_SECTION_NODE:
					{
						const gchar* _tmp183_;
						xmlNode* _tmp184_;
						const gchar* _tmp185_;
						gchar* _tmp186_;
						gchar* _tmp187_;
						gchar* _tmp188_;
						gchar* _tmp189_;
						gchar* _tmp190_;
						_tmp183_ = text;
						_tmp184_ = it;
						_tmp185_ = _tmp184_->content;
						_tmp186_ = g_strconcat ("\n\n```\n", _tmp185_, NULL);
						_tmp187_ = _tmp186_;
						_tmp188_ = g_strconcat (_tmp187_, "\n```", NULL);
						_tmp189_ = _tmp188_;
						_tmp190_ = g_strconcat (_tmp183_, _tmp189_, NULL);
						_g_free0 (text);
						text = _tmp190_;
						_g_free0 (_tmp189_);
						_g_free0 (_tmp187_);
						break;
					}
					default:
					break;
				}
			}
		}
	}
	_tmp191_ = text;
	_tmp192_ = string_strip (_tmp191_);
	result = _tmp192_;
	_g_free0 (text);
	return result;
}

gchar*
html_to_markdown_parse_list (xmlNode* n,
                             gboolean unordered,
                             gint depth)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gint index = 0;
	gint _tmp1_;
	gint _tmp45_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("");
	text = _tmp0_;
	index = 1;
	_tmp1_ = html_to_markdown_list_depth;
	html_to_markdown_list_depth = _tmp1_ + 1;
	{
		xmlNode* it = NULL;
		xmlNode* _tmp2_;
		_tmp2_ = n->children;
		it = _tmp2_;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp6_;
				gboolean _tmp7_ = FALSE;
				xmlNode* _tmp8_;
				xmlElementType _tmp9_;
				if (!_tmp3_) {
					xmlNode* _tmp4_;
					xmlNode* _tmp5_;
					_tmp4_ = it;
					_tmp5_ = _tmp4_->next;
					it = _tmp5_;
				}
				_tmp3_ = FALSE;
				_tmp6_ = it;
				if (!(_tmp6_ != NULL)) {
					break;
				}
				_tmp8_ = it;
				_tmp9_ = _tmp8_->type;
				if (_tmp9_ == XML_ELEMENT_NODE) {
					xmlNode* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					_tmp10_ = it;
					_tmp11_ = _tmp10_->name;
					_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
					_tmp13_ = _tmp12_;
					_tmp7_ = g_strcmp0 (_tmp13_, "li") == 0;
					_g_free0 (_tmp13_);
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					gint _tmp44_;
					if (unordered) {
						const gchar* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						gchar* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
						xmlNode* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						_tmp14_ = text;
						_tmp15_ = g_strnfill ((gsize) (html_to_markdown_list_depth * 4), ' ');
						_tmp16_ = _tmp15_;
						_tmp17_ = g_strconcat ("\n", _tmp16_, NULL);
						_tmp18_ = _tmp17_;
						_tmp19_ = g_strconcat (_tmp18_, "- ", NULL);
						_tmp20_ = _tmp19_;
						_tmp21_ = it;
						_tmp22_ = html_to_markdown_parse_item (_tmp21_);
						_tmp23_ = _tmp22_;
						_tmp24_ = g_strconcat (_tmp20_, _tmp23_, NULL);
						_tmp25_ = _tmp24_;
						_tmp26_ = g_strconcat (_tmp14_, _tmp25_, NULL);
						_g_free0 (text);
						text = _tmp26_;
						_g_free0 (_tmp25_);
						_g_free0 (_tmp23_);
						_g_free0 (_tmp20_);
						_g_free0 (_tmp18_);
						_g_free0 (_tmp16_);
					} else {
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
						xmlNode* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						_tmp27_ = text;
						_tmp28_ = g_strnfill ((gsize) (html_to_markdown_list_depth * 4), ' ');
						_tmp29_ = _tmp28_;
						_tmp30_ = g_strconcat ("\n", _tmp29_, NULL);
						_tmp31_ = _tmp30_;
						_tmp32_ = g_strdup_printf ("%i", index);
						_tmp33_ = _tmp32_;
						_tmp34_ = g_strconcat (_tmp31_, _tmp33_, NULL);
						_tmp35_ = _tmp34_;
						_tmp36_ = g_strconcat (_tmp35_, ". ", NULL);
						_tmp37_ = _tmp36_;
						_tmp38_ = it;
						_tmp39_ = html_to_markdown_parse_item (_tmp38_);
						_tmp40_ = _tmp39_;
						_tmp41_ = g_strconcat (_tmp37_, _tmp40_, NULL);
						_tmp42_ = _tmp41_;
						_tmp43_ = g_strconcat (_tmp27_, _tmp42_, NULL);
						_g_free0 (text);
						text = _tmp43_;
						_g_free0 (_tmp42_);
						_g_free0 (_tmp40_);
						_g_free0 (_tmp37_);
						_g_free0 (_tmp35_);
						_g_free0 (_tmp33_);
						_g_free0 (_tmp31_);
						_g_free0 (_tmp29_);
					}
					_tmp44_ = index;
					index = _tmp44_ + 1;
				}
			}
		}
	}
	_tmp45_ = html_to_markdown_list_depth;
	html_to_markdown_list_depth = _tmp45_ - 1;
	result = text;
	return result;
}

gchar*
html_to_markdown_parse_link (xmlNode* n)
{
	gchar* item = NULL;
	gchar* _tmp0_;
	gchar* h = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* result = NULL;
	_tmp0_ = html_to_markdown_parse_item (n);
	item = _tmp0_;
	_tmp1_ = (gchar*) xmlGetProp (n, (xmlChar*) "href");
	h = _tmp1_;
	_tmp3_ = h;
	if (_tmp3_ != NULL) {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		_tmp4_ = h;
		_tmp5_ = item;
		_tmp2_ = g_strcmp0 (_tmp4_, _tmp5_) != 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp6_ = item;
		_tmp7_ = g_strconcat ("[", _tmp6_, NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, "](", NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = h;
		_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strconcat (_tmp13_, ")", NULL);
		_tmp15_ = _tmp14_;
		_g_free0 (_tmp13_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		result = _tmp15_;
		_g_free0 (h);
		_g_free0 (item);
		return result;
	}
	result = item;
	_g_free0 (h);
	return result;
}

gchar*
html_to_markdown_parse_image (xmlNode* n)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gchar* s = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("");
	text = _tmp0_;
	_tmp1_ = (gchar*) xmlGetProp (n, (xmlChar*) "src");
	s = _tmp1_;
	_tmp2_ = s;
	if (_tmp2_ != NULL) {
		gchar* a = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "alt");
		a = _tmp3_;
		_tmp4_ = a;
		if (_tmp4_ != NULL) {
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp5_ = a;
			_tmp6_ = g_strconcat ("![", _tmp5_, NULL);
			_tmp7_ = _tmp6_;
			_tmp8_ = g_strconcat (_tmp7_, "](", NULL);
			_tmp9_ = _tmp8_;
			_tmp10_ = s;
			_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_strconcat (_tmp12_, ")", NULL);
			_g_free0 (text);
			text = _tmp13_;
			_g_free0 (_tmp12_);
			_g_free0 (_tmp9_);
			_g_free0 (_tmp7_);
		} else {
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp14_ = s;
			_tmp15_ = g_strconcat ("![](", _tmp14_, NULL);
			_tmp16_ = _tmp15_;
			_tmp17_ = g_strconcat (_tmp16_, ")", NULL);
			_g_free0 (text);
			text = _tmp17_;
			_g_free0 (_tmp16_);
		}
		_g_free0 (a);
	}
	result = text;
	_g_free0 (s);
	return result;
}

gchar*
html_to_markdown_parse_table (xmlNode* n)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gint row = 0;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("");
	text = _tmp0_;
	row = 0;
	{
		xmlNode* it = NULL;
		xmlNode* _tmp1_;
		_tmp1_ = n->children;
		it = _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp5_;
				gboolean _tmp6_ = FALSE;
				xmlNode* _tmp7_;
				xmlElementType _tmp8_;
				if (!_tmp2_) {
					xmlNode* _tmp3_;
					xmlNode* _tmp4_;
					_tmp3_ = it;
					_tmp4_ = _tmp3_->next;
					it = _tmp4_;
				}
				_tmp2_ = FALSE;
				_tmp5_ = it;
				if (!(_tmp5_ != NULL)) {
					break;
				}
				_tmp7_ = it;
				_tmp8_ = _tmp7_->type;
				if (_tmp8_ == XML_ELEMENT_NODE) {
					xmlNode* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					_tmp9_ = it;
					_tmp10_ = _tmp9_->name;
					_tmp11_ = g_utf8_strdown (_tmp10_, (gssize) -1);
					_tmp12_ = _tmp11_;
					_tmp6_ = g_strcmp0 (_tmp12_, "tr") == 0;
					_g_free0 (_tmp12_);
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					gint cols = 0;
					const gchar* _tmp13_;
					xmlNode* _tmp14_;
					gint _tmp15_ = 0;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gboolean _tmp23_ = FALSE;
					gint _tmp32_;
					_tmp13_ = text;
					_tmp14_ = it;
					_tmp16_ = html_to_markdown_parse_table_row (_tmp14_, &_tmp15_);
					cols = _tmp15_;
					_tmp17_ = _tmp16_;
					_tmp18_ = g_strconcat ("|", _tmp17_, NULL);
					_tmp19_ = _tmp18_;
					_tmp20_ = g_strconcat (_tmp19_, "\n", NULL);
					_tmp21_ = _tmp20_;
					_tmp22_ = g_strconcat (_tmp13_, _tmp21_, NULL);
					_g_free0 (text);
					text = _tmp22_;
					_g_free0 (_tmp21_);
					_g_free0 (_tmp19_);
					_g_free0 (_tmp17_);
					if (row == 0) {
						_tmp23_ = cols > 0;
					} else {
						_tmp23_ = FALSE;
					}
					if (_tmp23_) {
						const gchar* _tmp24_;
						gchar* _tmp25_;
						const gchar* _tmp30_;
						gchar* _tmp31_;
						_tmp24_ = text;
						_tmp25_ = g_strconcat (_tmp24_, "|", NULL);
						_g_free0 (text);
						text = _tmp25_;
						{
							gint col = 0;
							col = 0;
							{
								gboolean _tmp26_ = FALSE;
								_tmp26_ = TRUE;
								while (TRUE) {
									const gchar* _tmp28_;
									gchar* _tmp29_;
									if (!_tmp26_) {
										gint _tmp27_;
										_tmp27_ = col;
										col = _tmp27_ + 1;
									}
									_tmp26_ = FALSE;
									if (!(col < cols)) {
										break;
									}
									_tmp28_ = text;
									_tmp29_ = g_strconcat (_tmp28_, " - |", NULL);
									_g_free0 (text);
									text = _tmp29_;
								}
							}
						}
						_tmp30_ = text;
						_tmp31_ = g_strconcat (_tmp30_, "\n", NULL);
						_g_free0 (text);
						text = _tmp31_;
					}
					_tmp32_ = row;
					row = _tmp32_ + 1;
				}
			}
		}
	}
	_tmp33_ = text;
	_tmp34_ = string_strip (_tmp33_);
	result = _tmp34_;
	_g_free0 (text);
	return result;
}

gchar*
html_to_markdown_parse_table_row (xmlNode* n,
                                  gint* cols)
{
	gint _vala_cols = 0;
	gchar* text = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("");
	text = _tmp0_;
	_vala_cols = 0;
	{
		xmlNode* it = NULL;
		xmlNode* _tmp1_;
		_tmp1_ = n->children;
		it = _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp5_;
				xmlNode* _tmp6_;
				xmlElementType _tmp7_;
				if (!_tmp2_) {
					xmlNode* _tmp3_;
					xmlNode* _tmp4_;
					_tmp3_ = it;
					_tmp4_ = _tmp3_->next;
					it = _tmp4_;
				}
				_tmp2_ = FALSE;
				_tmp5_ = it;
				if (!(_tmp5_ != NULL)) {
					break;
				}
				_tmp6_ = it;
				_tmp7_ = _tmp6_->type;
				if (_tmp7_ == XML_ELEMENT_NODE) {
					xmlNode* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					GQuark _tmp13_ = 0U;
					static GQuark _tmp12_label0 = 0;
					static GQuark _tmp12_label1 = 0;
					_tmp8_ = it;
					_tmp9_ = _tmp8_->name;
					_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) -1);
					_tmp11_ = _tmp10_;
					_tmp13_ = (NULL == _tmp11_) ? 0 : g_quark_from_string (_tmp11_);
					g_free (_tmp11_);
					if ((_tmp13_ == ((0 != _tmp12_label0) ? _tmp12_label0 : (_tmp12_label0 = g_quark_from_static_string ("th")))) || (_tmp13_ == ((0 != _tmp12_label1) ? _tmp12_label1 : (_tmp12_label1 = g_quark_from_static_string ("td"))))) {
						switch (0) {
							default:
							{
								const gchar* _tmp14_;
								xmlNode* _tmp15_;
								gchar* _tmp16_;
								gchar* _tmp17_;
								gchar* _tmp18_;
								gchar* _tmp19_;
								gchar* _tmp20_;
								gchar* _tmp21_;
								gchar* _tmp22_;
								gint _tmp23_;
								_tmp14_ = text;
								_tmp15_ = it;
								_tmp16_ = html_to_markdown_parse_item (_tmp15_);
								_tmp17_ = _tmp16_;
								_tmp18_ = g_strconcat (" ", _tmp17_, NULL);
								_tmp19_ = _tmp18_;
								_tmp20_ = g_strconcat (_tmp19_, " |", NULL);
								_tmp21_ = _tmp20_;
								_tmp22_ = g_strconcat (_tmp14_, _tmp21_, NULL);
								_g_free0 (text);
								text = _tmp22_;
								_g_free0 (_tmp21_);
								_g_free0 (_tmp19_);
								_g_free0 (_tmp17_);
								_tmp23_ = _vala_cols;
								_vala_cols = _tmp23_ + 1;
								break;
							}
						}
					}
				}
			}
		}
	}
	result = text;
	if (cols) {
		*cols = _vala_cols;
	}
	return result;
}

gchar*
html_to_markdown_parse_node (xmlNode* n)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* result = NULL;
	_tmp0_ = n->name;
	_tmp1_ = g_strconcat ("<", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, ">", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = html_to_markdown_parse_item (n);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp4_, _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp8_, "</", NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = n->name;
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, ">", NULL);
	_tmp15_ = _tmp14_;
	_g_free0 (_tmp13_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp15_;
	return result;
}

HtmlToMarkdown*
html_to_markdown_construct (GType object_type)
{
	HtmlToMarkdown* self = NULL;
	self = (HtmlToMarkdown*) g_type_create_instance (object_type);
	return self;
}

HtmlToMarkdown*
html_to_markdown_new (void)
{
	return html_to_markdown_construct (TYPE_HTML_TO_MARKDOWN);
}

static void
value_html_to_markdown_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_html_to_markdown_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		html_to_markdown_unref (value->data[0].v_pointer);
	}
}

static void
value_html_to_markdown_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = html_to_markdown_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_html_to_markdown_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_html_to_markdown_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		HtmlToMarkdown * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = html_to_markdown_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_html_to_markdown_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	HtmlToMarkdown ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = html_to_markdown_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_html_to_markdown (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecHtmlToMarkdown* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HTML_TO_MARKDOWN), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_html_to_markdown (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTML_TO_MARKDOWN), NULL);
	return value->data[0].v_pointer;
}

void
value_set_html_to_markdown (GValue* value,
                            gpointer v_object)
{
	HtmlToMarkdown * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTML_TO_MARKDOWN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HTML_TO_MARKDOWN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		html_to_markdown_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		html_to_markdown_unref (old);
	}
}

void
value_take_html_to_markdown (GValue* value,
                             gpointer v_object)
{
	HtmlToMarkdown * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HTML_TO_MARKDOWN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HTML_TO_MARKDOWN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		html_to_markdown_unref (old);
	}
}

static void
html_to_markdown_class_init (HtmlToMarkdownClass * klass,
                             gpointer klass_data)
{
	html_to_markdown_parent_class = g_type_class_peek_parent (klass);
	((HtmlToMarkdownClass *) klass)->finalize = html_to_markdown_finalize;
}

static void
html_to_markdown_instance_init (HtmlToMarkdown * self,
                                gpointer klass)
{
	self->ref_count = 1;
}

static void
html_to_markdown_finalize (HtmlToMarkdown * obj)
{
	HtmlToMarkdown * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HTML_TO_MARKDOWN, HtmlToMarkdown);
	g_signal_handlers_destroy (self);
}

static GType
html_to_markdown_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_html_to_markdown_init, value_html_to_markdown_free_value, value_html_to_markdown_copy_value, value_html_to_markdown_peek_pointer, "p", value_html_to_markdown_collect_value, "p", value_html_to_markdown_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HtmlToMarkdownClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) html_to_markdown_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HtmlToMarkdown), 0, (GInstanceInitFunc) html_to_markdown_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType html_to_markdown_type_id;
	html_to_markdown_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HtmlToMarkdown", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return html_to_markdown_type_id;
}

GType
html_to_markdown_get_type (void)
{
	static volatile gsize html_to_markdown_type_id__volatile = 0;
	if (g_once_init_enter (&html_to_markdown_type_id__volatile)) {
		GType html_to_markdown_type_id;
		html_to_markdown_type_id = html_to_markdown_get_type_once ();
		g_once_init_leave (&html_to_markdown_type_id__volatile, html_to_markdown_type_id);
	}
	return html_to_markdown_type_id__volatile;
}

gpointer
html_to_markdown_ref (gpointer instance)
{
	HtmlToMarkdown * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
html_to_markdown_unref (gpointer instance)
{
	HtmlToMarkdown * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		HTML_TO_MARKDOWN_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

